datablock AudioProfile(MedAPShellExplodeSound)
{
   filename    = "./APHit.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ParticleData(MedAPShellTrailParticle)
{
	dragCoefficient      = 3;
	Coefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 805;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "0.6 0.6 1.0 0.3";
	colors[1]     = "0.8 0.8 1.0 0.7";
   colors[2]     = "0.30 0.30 0.50 0.3";
   colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 0.25;
	sizes[1]      = 0.85;
   sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(MedAPShellTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MedAPShellTrailParticle";

   uiName = "AP Shell Trail";
};

datablock ParticleData(MedAPShellExplosionParticle)
{
	dragCoefficient      = 3;
	Coefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.9";
	colors[1]     = "0.05 0.0 0.0 1.0";
	colors[2]     = "0.2 0.2 0.2 0.0";
	sizes[0]      = 3.0;
	sizes[1]      = 5.0;
	sizes[2]      = 5.5;
	times[0] = 0.0;
	times[1] = 0.05;
	times[2] = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(MedAPShellExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.5;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MedAPShellExplosionParticle";

   uiName = "AP Shell Explosion Smoke";
   emitterNode = TenthEmitterNode;
};


datablock ParticleData(MedAPShellExplosionRingParticle)
{
	dragCoefficient      = 8;
	Coefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 60;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.8 1.0 1.0";
	colors[1]     = "0.4 0.4 0.9 0.0";
	sizes[0]      = 2;
	sizes[1]      = 3;

	useInvAlpha = false;
};
datablock ParticleEmitterData(MedAPShellExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MedAPShellExplosionRingParticle";

   uiName = "AP Shell Explosion Flash";
};

datablock ExplosionData(MedAPShellExplosion)
{
   explosionShape = "";
   soundProfile = MedAPShellExplodeSound;

   lifeTimeMS = 150;


   particleEmitter = MedAPShellExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = MedAPShellExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 1.5;
   radiusDamage = 50;

   impulseRadius = 3;
   impulseForce = 9000;

   playerBurnTime = 5000;
};

AddDamageType("MedAPShellDirect",   '<bitmap:add-ons/Projectile_GravityRocket/Rocket> %1',    '%2 <bitmap:add-ons/Projectile_GravityRocket/Rocket> %1',1,1);
AddDamageType("MedAPShellRadius",   '<bitmap:add-ons/Projectile_GravityRocket/RocketRadius> %1',    '%2 <bitmap:add-ons/Projectile_GravityRocket/RocketRadius> %1',1,0);
datablock ProjectileData(MedAPShellProjectile)
{
   projectileShapeName = "./APShell.dts";
   directDamage        = 100;
   directDamageType = $DamageType::MedAPShellDirect;
   radiusDamageType = $DamageType::MedAPShellRadius;
   impactImpulse	   = 4000;
   verticalImpulse	   = 1000;
   explosion           = MedAPShellExplosion;
   particleEmitter     = MedAPShellTrailEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 200;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 400;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = "";

   muzzleVelocity      = 150;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.1;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   explodeOnDeath = 1;

   uiName = "Med. AP Shell";
};

   function MedAPShellProjectile::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e)
   {
      if(%col.dataBlock.className $= "Glass" && !%col.indestructable)
      {
         %col.explode();
      }
      Parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e);
   }

function MedAPShellProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
    if(%this.directDamage <= 0)
        return;

   %damageType = $DamageType::Direct;
    if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 1);
   %directDamage = %this.directDamage * 2.5;

    if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
    }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
    }
}