datablock TSShapeConstructor(BPzIVTurretDts)
{
	baseShape  = "./BPzIVturret.dts";
	sequence0  = "./ptank_root.dsq root";

	sequence1  = "./ptank_root.dsq run";
	sequence2  = "./ptank_root.dsq walk";
	sequence3  = "./ptank_root.dsq back";
	sequence4  = "./ptank_root.dsq side";

	sequence5  = "./ptank_root.dsq crouch";
	sequence6  = "./ptank_root.dsq crouchRun";
	sequence7  = "./ptank_root.dsq crouchBack";
	sequence8  = "./ptank_root.dsq crouchSide";

	sequence9  = "./ptank_look.dsq look";
	sequence10 = "./ptank_root.dsq headside";
	sequence11 = "./ptank_root.dsq headUp";

	sequence12 = "./ptank_root.dsq jump";
	sequence13 = "./ptank_root.dsq standjump";
	sequence14 = "./ptank_root.dsq fall";
	sequence15 = "./ptank_root.dsq land";

	sequence16 = "./ptank_root.dsq armAttack";
	sequence17 = "./ptank_root.dsq armReadyLeft";
	sequence18 = "./ptank_root.dsq armReadyRight";
	sequence19 = "./ptank_root.dsq armReadyBoth";
	sequence20 = "./ptank_root.dsq spearready";  
	sequence21 = "./ptank_root.dsq spearThrow";

	sequence22 = "./ptank_root.dsq talk";  

	sequence23 = "./ptank_root.dsq death1"; 
	
	sequence24 = "./ptank_root.dsq shiftUp";
	sequence25 = "./ptank_root.dsq shiftDown";
	sequence26 = "./ptank_root.dsq shiftAway";
	sequence27 = "./ptank_root.dsq shiftTo";
	sequence28 = "./ptank_root.dsq shiftLeft";
	sequence29 = "./ptank_root.dsq shiftRight";
	sequence30 = "./ptank_root.dsq rotCW";
	sequence31 = "./ptank_root.dsq rotCCW";

	sequence32 = "./ptank_root.dsq undo";
	sequence33 = "./ptank_root.dsq plant";

	sequence34 = "./ptank_root.dsq sit";

	sequence35 = "./ptank_root.dsq wrench";
};    

datablock PlayerData(BPzIVTurretPlayer)
{
   renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./BPzIVTurret.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;
   cameraVerticalOffset = 2.3;
     
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 0.5;
   maxFreelookAngle = 3.0;

   mass = 200000;
   drag = 1;
   density = 5;
   maxDamage = 300;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 1000;
   runEnergyDrain   = 0;
   minRunEnergy     = 0;
   maxForwardSpeed  = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed     = 0;

   maxForwardCrouchSpeed  = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed     = 0;

   maxUnderwaterForwardSpeed  = 0;
   maxUnderwaterBackwardSpeed = 0;
   maxUnderwaterSideSpeed     = 0;

   jumpForce       = 0; 
   jumpEnergyDrain = 0;
   minJumpEnergy   = 0;
   jumpDelay       = 0;

   minJetEnergy   = 0;
	jetEnergyDrain = 0;
	canJet         = 0;

   minImpactSpeed   = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("3 3 1.7", 4); 
   crouchBoundingBox	= vectorScale("3 3 1.7", 4); 
   
   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
   jetEmitter        = "";
   jetGroundEmitter  = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound = "";

   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "BPz.IV Turret";
	rideable = true;
   lookUpLimit = 0.6;
   lookDownLimit = 0.4;

	canRide = true;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "root";

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?

   useCustomPainEffects = true;
   PainHighImage = "";
   PainMidImage  = "";
   PainLowImage  = "";
   painSound     = "";
   deathSound    = "";
};

datablock WheeledVehicleData(BPzIVVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./BPzIVHull.dts";
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 3;
   mountThread[0] = "root";
   mountThread[1] = "root";
   mountThread[2] = "root";

	maxDamage = 450.00;
	destroyedLevel = 300.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= tankTire;
	defaultSpring	= tankSpring;

   numWheels = 4;

	// Rigid Body
	mass = 500;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 9;       // Play SoftImpact Sound
	hardImpactSpeed = 13;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 20000; //4000;       // Engine power
	engineBrake = 5000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 14;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = rocketLoopSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Blocko Pz. IV";
	rideable = true;
   //lookUpLimit = 0.9;
   //lookDownLimit = 0.1;
   lookUpLimit  = 0.5;
   lookDownLimit = 0.5;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = tankExplosionProjectile;
   initialExplosionOffset = 1;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = tankFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 25;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = false;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};

function BPzIVVehicle::onAdd(%this,%obj)
{
   // Setup the car with some defaults tires & springs
   for(%i = 0; %i < %this.numWheels; %i++)
   {
      %obj.setWheelTire(%i, %this.defaultTire);
      %obj.setWheelSpring(%i, %this.defaultSpring);
   }

   // 4 wheel steering
   %obj.setWheelSteering(0,0.8);
   %obj.setWheelSteering(1,0.8);
   %obj.setWheelSteering(2,-0.4);
   %obj.setWheelSteering(3,-0.4);

   // 4 wheel drive
   %obj.setWheelPowered(0,true);
   %obj.setWheelPowered(1,true);
   %obj.setWheelPowered(2,true);
   %obj.setWheelPowered(3,true);

   // turret
   %t = new AIPlayer()
   {
      dataBlock = BPzIVTurretPlayer;
   };
   if(isObject(%t)) //creation can fail due to quota limit
   {
      MissionCleanup.add(%t);
      %obj.mountObject(%t, 1);
      %obj.turret = %t;
      %t.schedule(10,"rigTurret");
   }

   %obj.creationTime = getSimTime();      
}

function Player::rigTurret(%obj)
{
   if(%obj.dataBlock !$= BPzIVTurretPlayer)
	   return;

   if(!isObject(%obj))
	   return;

   %parent = %obj.getObjectMount();
   if(!isObject(%parent))
	   return;

   %obj.spawnBrick = %parent.spawnBrick;
   %obj.brickGroup = %parent.brickGroup;
}

function BPzIVVehicle::onRemove(%this,%obj)
{
   if(isObject(%obj.turret))
	   %obj.turret.delete();
}

function BPzIVTurretPlayer::onAdd(%this, %obj)
{
   %obj.lastShotTime = getSimTime() - 2000;
   Parent::onAdd(%this, %obj);
}

package BPzIVPackage
{
   function Player::burn(%obj,%time)
   {
      if(%obj.dataBlock $= BPzIVTurretPlayer)
         return;
      else
         Parent::burn(%obj,%time);
   }

   function ShapeBase::setNodeColor(%obj,%node,%color)
   {
      Parent::setnodecolor(%obj,%node,%color);
      if(isObject(%obj.turret))
      {
         %obj.turret.setNodeColor("ALL",%color);
      }
   }

   function BPzIVVehicle::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      if((%obj.getDamageLevel()+%amm) >= %this.maxDamage)
      {
         if(%obj.destroyed)
            return;

         %obj.setNodeColor("ALL","0 0 0 1");
         if(isObject(%obj.turret))
         {
            %obj.turret.delete();
            %p = new Projectile()
            {
               dataBlock = BPzIVTurretExplosionProjectile;
               initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               initialVelocity = "0 0 1";
               client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
            };
            MissionCleanup.add(%p);
         }
         else
         {
            %p = new Projectile()
            {
               dataBlock = TankExplosionProjectile;
               initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               initialVelocity = "0 0 1";
               client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
            };
            MissionCleanup.add(%p);
         }
         if(%obj.destroyed)
            return;

         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(%this.burnTime,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
      }
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function Player::emote(%obj,%emote)
   {
      if(%obj.dataBlock $= BPzIVTurretPlayer)
	      return;
      Parent::emote(%obj,%emote);
   }

   function BPzIVTurretPlayer::onDisabled(%this,%obj,%state)
   {
      %BPzIV = %obj.getObjectMount();
      if(isObject(%BPzIV))
         %pos = vectorAdd(%obj.getObjectMount().getPosition(),"0 0" SPC %obj.getObjectMount().dataBlock.initialExplosionOffset);
      else
         %pos = %obj.getHackPosition();

      %p = new Projectile()
      {
         dataBlock = BPzIVTurretExplosionProjectile;
         initialPosition = %pos;
         initialVelocity = "0 0 1";
         client = %obj.lastDamageClient;
         sourceClient = %obj.lastDamageClient;
      };
      MissionCleanup.add(%p);
      %obj.schedule(10,"delete");

      //mount the guy who was in the turret to the BPzIV
      if(isObject(%BPzIV))
      {
         %player = %obj.getMountedObject(0);
         %turretNode = %obj.getMountNode();
         if(isObject(%player))
         {
            %obj.getObjectMount().schedule(10,"mountObject",%player,%turretNode);
         }
      }
   
      if(isObject(%obj.spawnBrick) && %obj.spawnBrick.vehicle == %obj)
      {
         %mg = getMiniGameFromObject(%obj);
         if(isObject(%mg))
         {
            %obj.spawnBrick.spawnVehicle(%mg.vehicleReSpawnTime);
         }
         else
         {
            %obj.spawnBrick.spawnVehicle(5000);
         }         

         Parent::onDisabled(%this,%obj,%state);              
      }
     
   }  

   function BPzIVTurretPlayer::Damage(%data,%obj,%source,%pos,%amm,%type)
   {
      //scale the damage ammount as if this was a vehicle     
      %amm *= $Damage::VehicleDamageScale[%type];

      if(%obj.getDamageLevel()+%amm > %data.maxDamage && !isObject(%obj.client))
         %obj.setDamageLevel(%data.maxDamage);
      else
         Parent::Damage(%data,%obj,%source,%pos,%amm,%type);
   }

   function armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this,%obj,%col,%slot);
      if(%col.getDataBlock() == BPzIVVehicle.getId())
      {
         if(%slot $= 1)
         {
            %obj.setLookLimits(1,0);
         }
      }
      else if(%col.getDataBlock() == BPzIVTurretPlayer.getId())
      {
         %client = %obj.client;
         if(isObject(%client))
            ServerCmdUnUseTool(%client);
      }
   }

   function armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
      %mount = %obj.getObjectMount();

      //hack so we can shoot if we are a BPzIV turret
      if(%obj.getDataBlock().getID() == BPzIVTurretPlayer.getID())
         %mount = %obj;

      if(isObject(%mount))
      {
         if(%mount.getDataBlock() == BPzIVTurretPlayer.getId() && %triggerNum == 0 && %val)
         {
            %client = %obj.client;
            if(isObject(%client))
               ServerCmdUnUseTool(%client);

            if(getSimTime() - %mount.lastShotTime < 2500)
               return;
            
            %scaleFactor = getWord(%mount.getScale(), 2);
            %p = new Projectile()
            {
               dataBlock = MedAPShellProjectile;
               initialPosition = %mount.getSlotTransform(1);
               initialVelocity = vectorScale(%mount.getMuzzleVector(1),140 * %scaleFactor);
               sourceObject = %obj;
               client = %obj.client;
               sourceSlot = 0;
               originPoint = %mount.getSlotTransform(1);
            };
            MissionCleanup.add(%p);
            %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);

            %mount.mountImage(TankSmokeImage,1);

            serverPlay3D(TankshotSound,%obj.getPosition());
         
            %BPzIV = %mount.getObjectMount();
            if(isObject(%BPzIV))
            {
               %theVector = %mount.getEyeVector();
               %theVector = vectorAdd(%theVector,"0 0 1");
               %theVector = vectorScale(%theVector,%BPzIV.getDataBlock().mass*5);
               %theVector = vectorSub(%theVector,vectorScale(%thevector,2));
               
               %BPzIV.applyImpulse(getWords(%mount.getEyeTransform(),0,2),%theVector);	
            }
            
            %obj.playThread(0,activate);
            %mount.lastShotTime = getSimTime();

            return;
         }
      }
      
      Parent::onTrigger(%this,%obj,%triggerNum,%val);
   }
};
activatepackage(BPzIVPackage);

datablock DebrisData(BPzIVturretDebris)
{
   emitters = "jeepDebrisTrailEmitter";

	shapeFile = "./BPzIVturretDebris.dts";
	lifetime = 3.0;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(BPzIVTurretExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleExplosionEmitter;
   emitter[1] = vehicleExplosionEmitter2;

   debris = BPzIVturretDebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 20;
   debrisVelocity = 18;
   debrisVelocityVariance = 3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   radiusDamage        = 30;
   damageRadius        = 8.0;

   //burn the players?
   playerBurnTime = 5000;

};

datablock ProjectileData(BPzIVTurretExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = BPzIVTurretExplosion;

   directDamageType  = $DamageType::jeepExplosion;
   radiusDamageType  = $DamageType::jeepExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
};
